config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html
  
  # Defines the root path route ("/")
  root 'tasks#index'
  resources :tasks
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/task.rb
class Task < ApplicationRecord
  belongs_to :user
  broadcasts_to ->(_) { :tasks }
  scope :completed, -> { where(status: true).count }
  scope :incomplete, -> { where(status: false).count }

  validates :title, presence: true
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
  
  has_many :tasks, dependent: :destroy
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  before_action :authenticate_user!
  before_action :turbo_frame_request_variant
  
  private

  def turbo_frame_request_variant
    request.variant = :turbo_frame if turbo_frame_request?
  end
end

app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  before_action :set_task, only: %i[ show edit update destroy ]

  # ? GET /tasks or /tasks.json
  def index
    if params[:query].present?
      @tasks = current_user.tasks.where('title like ?', "%#{params[:query]}%")
    else
      @tasks = current_user.tasks
    end
    
    if turbo_frame_request? && controller_name == 'tasks'
      render partial: 'tasks', locals: { tasks: @tasks }
    else
      render 'index'
    end
  end

  # ? GET /tasks/1 or /tasks/1.json
  def show; end

  # ? GET /tasks/new
  def new
    @task = current_user.tasks.build
  end

  # ? GET /tasks/1/edit
  def edit
  end

  # ? POST /tasks or /tasks.json
  def create
    @task = current_user.tasks.build(task_params)

    respond_to do |format|
      if @task.save
        format.html { redirect_to root_url, notice: "Task was successfully created." }
        format.json { render :show, status: :created, location: @task }
        format.turbo_stream
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @task.errors, status: :unprocessable_entity }
        format.turbo_stream
      end
    end
  end

  # ? PATCH/PUT /tasks/1 or /tasks/1.json
  def update
    respond_to do |format|
      if @task.update(task_params)
        format.html { redirect_to root_url, notice: "Task was successfully updated." }
        format.json { render :show, status: :ok, location: @task }
        format.turbo_stream
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @task.errors, status: :unprocessable_entity }
      end
    end
  end

  # ? DELETE /tasks/1 or /tasks/1.json
  def destroy
    @task.destroy

    respond_to do |format|
      format.html { redirect_to root_url, notice: "Task was successfully destroyed." }
      format.json { head :no_content }
      format.turbo_stream
    end
  end

  private

  # ? Use callbacks to share common setup or constraints between actions.
  def set_task
    @task = Task.find(params[:id])
  end

  # ? Only allow a list of trusted parameters through.
  def task_params
    params.require(:task).permit(:title, :status, :user_id)
  end
end

app/controllers/users/devise_controller.rb
class Users::DeviseController < ApplicationController
  class Responder < ActionController::Responder
    def to_turbo_stream
      controller.render(options.merge(formats: :html))
    rescue ActionView::MissingTemplate => error
      if get?
        raise error
      elsif has_errors? && default_action
        render rendering_options.merge(formats: :html, status: :unprocessable_entity)
      else
        redirect_to navigation_location
      end
    end
  end

  self.responder = Responder
  respond_to :html, :turbo_stream
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/tasks_helper.rb
module TasksHelper
  def flash_color(key)
    case key
    when 'notice' then 'bg-green-700'
    when 'alert' then 'bg-yellow-700'
    when 'error' then 'bg-red-700'
    else 
      'bg-purple-700'
    end
  end
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>SimpleTask</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_include_tag "application", "data-turbo-track": "reload", defer: true %>
    <%= hotwire_livereload_tags %>

  </head>

  <body class="flex lg:flex-row md:flex-row sm:flex-col">
    <%= render "shared/navbar" %>
    <div class="container border w-full h-auto min-h-screen">
      <%= turbo_frame_tag :messages %>
      
      <% flash.each do |key, message| %>
        <%= render partial: 'shared/flash', locals: { key: key, message: message } %>
      <% end %>

      <h1 class="text-center text-4xl p-4 border">Tasks</h1>

      <%= yield %>
    </div>
  </body>
</html>

app/views/shared/_dashboard.html.erb
<div class="flex gap-2 justify-around md:flex-col lg:flex-row sm:flex-col md:items-center sm:items-center">
  <div class="flex flex-col border border-green-500 p-4 text-center w-96 h-96 mt-3 shadow-md rounded-md">
    <h1 class="text-4xl font-serif">Complete</h1>
    <span class="font-semibold p-20 mt-6 text-9xl">
      <%= current_user.tasks.completed %>
    </span>
  </div>

  <div class="flex flex-col border border-purple-500 p-4 text-center w-96 h-96 mt-3 shadow-sm rounded-md">
    <h1 class="text-4xl font-serif">Incomplete</h1>
    <span class="font-semibold p-20 mt-6 text-9xl">
      <%= current_user.tasks.incomplete %>
    </span>
  </div>
</div>

app/views/shared/_flash.html.erb
<div class="fixed w-96 right-0" data-controller="flash">
  <div class="flex w-full justify-between justify-items-stretch p-5 rounded-lg shadow <%= flash_color(key) %> text-white">
	<div>
	  <svg class="w-6 h-6 fill-current text-green-500" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M0 0h24v24H0V0z" fill="none"/><path d="M12 2C6.48 2 2 6.48 2 12s4.48 10 10 10 10-4.48 10-10S17.52 2 12 2zm0 18c-4.41 0-8-3.59-8-8s3.59-8 8-8 8 3.59 8 8-3.59 8-8 8zm4.59-12.42L10 14.17l-2.59-2.58L6 13l4 4 8-8z"/></svg>
	  <h2 class="font-semibold text-white">SimpleTask</h2>
	  <p class="mt-2 text-sm text-white leading-relaxed">
      <%= message %>
    </p>
	</div>
	<svg xmlns="http://www.w3.org/2000/svg" class="h-5 w-5 cursor-pointer" viewBox="0 0 20 20" fill="currentColor" data-action="click->flash#dismiss">
		<path fill-rule="evenodd" d="M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z" clip-rule="evenodd" />
	</svg>
  </div>
</div>

app/views/shared/_navbar.html.erb
<!-- component -->
<nav class="col-span-2 rounded-md w-96 h-full justify-between">
	<div class=" bg-white h-full">
		<div class="flex  justify-center py-10 shadow-sm pr-4">
			<svg xmlns="http://www.w3.org/2000/svg" class="h-14 w-14 text-indigo-600" fill="none" viewBox="0 0 24 24"
				stroke="currentColor">
				<path stroke-linecap="round" stroke-linejoin="round" stroke-width="2"
					d="M9 3v2m6-2v2M9 19v2m6-2v2M5 9H3m2 6H3m18-6h-2m2 6h-2M7 19h10a2 2 0 002-2V7a2 2 0 00-2-2H7a2 2 0 00-2 2v10a2 2 0 002 2zM9 9h6v6H9V9z" />
			</svg>
			<div class="pl-2">
				<%= link_to root_path do %>
					<p class="text-2xl font-bold text-indigo-600">TASKS</h1>
					<span class="text-xs block text-gray-800">Lists</span>
				<% end %>
				
			</div>
		</div>
		<div class="pl-10 mb-6">
			<% if user_signed_in? %>
				<span class="text-xs font-bold block text-gray-800 p-5">
					Welcome back <%= current_user.email %>
				</span>

				<div class="bg-white flex items-center space-x-4 pl-10 pb-10 hover:text-indigo-600 cursor-pointer">
					<svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor">
						<path stroke-linecap="round" stroke-linejoin="round" stroke-width="2"
							d="M17 16l4-4m0 0l-4-4m4 4H7m6 4v1a3 3 0 01-3 3H6a3 3 0 01-3-3V7a3 3 0 013-3h4a3 3 0 013 3v1" />
					</svg>
					<%= button_to 'Logout', destroy_user_session_path, method: :delete %>
				</div>

				<div  class="w-full mt-6 mx-auto">
					<%= link_to '+ New Task', new_task_path, class: 'btn-primary', 'data-turbo-frame': 'task' %>
				</div>
				
        <%= turbo_stream_from :tasks %>

				<div class="space-y-8 pt-10 mr-4 mb-5">
					<%= form_with(
						url: root_path, 
						method: :get,
						class: 'flex flex-col',
						data: { controller: 'task', turbo_frame: 'tasks',turbo_action: 'advance'}
					) do |f| %>
					  <%= f.label :query, 'Pesquisar' %>
						<%= f.text_field :query, data: { action: 'input->task#search'} %>
					<% end %>
				</div>

				<%= turbo_frame_tag :tasks, class: 'space-y-8 pt-10' do %>
					<%= render @tasks %>
				<% end %>
		</div>
	</div>
	
<% else %>
	<div class="bg-white flex items-center space-x-4 pl-10 pb-10 hover:text-indigo-600 cursor-pointer">
		<svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6" fill="none" viewBox="0 0 24 24" stroke="currentColor">
			<path stroke-linecap="round" stroke-linejoin="round" stroke-width="2"
				d="M17 16l4-4m0 0l-4-4m4 4H7m6 4v1a3 3 0 01-3 3H6a3 3 0 01-3-3V7a3 3 0 013-3h4a3 3 0 013 3v1" />
		</svg>
		<%= link_to 'Login', new_user_session_path %>
	</div>
 <% end %>
</nav>

app/views/tasks/_form.html.erb
<%= form_with(
  model: task,
  html: { id: 'task_form', class: 'w-full', data: { controller: 'form' } }
) do |form| %>
  <% if task.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(task.errors.count, "error") %> prohibited this task from being saved:</h2>

      <ul>
        <% task.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <%= form.hidden_field :user_id, value: current_user.id %>

  <div class="mb-6">
    <%= form.label :title, class: 'label'  %>
    <%= form.text_field :title, autofocus: true, class: 'form-input w-full p-2 rounded', data: { action: 'focusout->form#focusout focus->form#focus'} %>
  </div>


  <div>
    <%= form.label :status,  class: 'label' %>
    <%= form.check_box :status, class: 'form-checkbox h-5 w-5 text-blue-600 rounded' %>
  </div>

  <div class="flex justify-between mt-6">
    <%= form.submit nil, class: 'btn-primary' %>

    <%= link_to 'Cancelar', root_url, class: 'btn-danger' %>
  </div>
<% end %>

app/views/tasks/_task.html.erb
<li id="<%= dom_id task %>" class="flex space-x-4 items-center hover:text-indigo-600 cursor-pointer <%= task.status ? 'text-green-600' : '' %>">
  <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6 <%= task.status ? 'text-green-600' : '' %>" fill="none" viewBox="0 0 24 24"
    stroke="currentColor">
    <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2"
      d="M9 17V7m0 10a2 2 0 01-2 2H5a2 2 0 01-2-2V7a2 2 0 012-2h2a2 2 0 012 2m0 10a2 2 0 002 2h2a2 2 0 002-2M9 7a2 2 0 012-2h2a2 2 0 012 2m0 10V7m0 10a2 2 0 002 2h2a2 2 0 002-2V7a2 2 0 00-2-2h-2a2 2 0 00-2 2" />
  </svg>
  <span class="text-sm font-semibold <%= task.status ? 'line-through' : '' %>"><%= task.title %></span>
  <% if action_name != 'show' %>
    <%= form_with(model: task) do |form| %>
    <%= form.check_box :status, data: { controller: 'task', action: 'click->task#update'} %>
    <% end %>
    <%= link_to edit_task_url(task), 'data-turbo-frame': 'task'  do %>
      <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6 text-green-500" fill="none" viewBox="0 0 24 24" stroke="currentColor">
        <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M11 5H6a2 2 0 00-2 2v11a2 2 0 002 2h11a2 2 0 002-2v-5m-1.414-9.414a2 2 0 112.828 2.828L11.828 15H9v-2.828l8.586-8.586z" />
      </svg>
    <% end %>
    <%= button_to task_path(task), method: :delete, form: { data: { turbo_confirm: 'Remove task ?' } } do %>
      <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6 text-red-500" fill="none" viewBox="0 0 24 24" stroke="currentColor">
        <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M19 7l-.867 12.142A2 2 0 0116.138 21H7.862a2 2 0 01-1.995-1.858L5 7m5 4v6m4-6v6m1-10V4a1 1 0 00-1-1h-4a1 1 0 00-1 1v3M4 7h16" />
      </svg>
    <% end %>
  <% end %>
</li>

app/views/tasks/_tasks.html.erb
	<%= turbo_frame_tag :tasks, class: 'space-y-8 pt-10' do %>
    <%= render tasks %>
  <% end %>

app/views/tasks/create.turbo_stream.erb
<%# turbo_stream.append('tasks') do %>
  <%# render partial: 'tasks/task', locals: { task: @task } %>
<%# end %>
<% if @task.errors.any? %>

  <%= turbo_stream.replace 'task_form' do %>
    <%= render partial: 'tasks/form', locals: { task: @task } %>
  <% end %>

<% else %>

  <%= turbo_stream.update :messages do %>
    <%= render partial: 'shared/flash', locals: { key: 'notice', message: 'Task created with successfully' } %>
  <% end %>

  <%= turbo_stream.replace :task do %>
    <%= turbo_frame_tag :task do %>
      <%= render partial: 'shared/dashboard' %>
    <% end %>
  <% end %>
  
<% end %>

app/views/tasks/destroy.turbo_stream.erb
<%# turbo_stream.remove(@task) %>

<%= turbo_stream.update :messages do %>
  <%= render partial: 'shared/flash', locals: { key: 'error', message: 'Task removed successfully' } %>
<% end %>

<%= turbo_stream.replace :task do %>
  <%= turbo_frame_tag :task do %>
    <%= render partial: 'shared/dashboard' %>
  <% end %>
<% end %>

app/views/tasks/edit.html.erb
<%= turbo_frame_tag :task do %>
    <!-- This example requires Tailwind CSS v2.0+ -->
<div class="fixed z-10 inset-0 overflow-y-auto" aria-labelledby="modal-title" role="dialog" aria-modal="true">
  <div class="flex items-end justify-center min-h-screen pt-4 px-4 pb-20 text-center sm:block sm:p-0">
    <div class="fixed inset-0 bg-gray-500 bg-opacity-75 transition-opacity" aria-hidden="true"></div>
    <!-- This element is to trick the browser into centering the modal contents. -->
    <span class="hidden sm:inline-block sm:align-middle sm:h-screen" aria-hidden="true">&#8203;</span>
    <div class="inline-block align-bottom bg-white rounded-lg text-left overflow-hidden shadow-xl transform transition-all sm:my-8 sm:align-middle sm:max-w-lg sm:w-full">
      <div class="bg-white px-4 pt-5 pb-4 sm:p-6 sm:pb-4">
        <div class="sm:flex sm:items-start">
          <div class="mx-auto flex-shrink-0 flex items-center justify-center h-12 w-12 rounded-full bg-red-100 sm:mx-0 sm:h-10 sm:w-10">
            <!-- Heroicon name: outline/exclamation -->
            <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6 text-green-600" fill="none" viewBox="0 0 24 24" stroke="currentColor">
              <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M11 5H6a2 2 0 00-2 2v11a2 2 0 002 2h11a2 2 0 002-2v-5m-1.414-9.414a2 2 0 112.828 2.828L11.828 15H9v-2.828l8.586-8.586z" />
            </svg>
          </div>
          <div class="mt-3 text-center sm:mt-0 sm:ml-4 sm:text-left w-full">
            <h3 class="text-lg leading-6 font-medium text-gray-900" id="modal-title">
              Edit Task
            </h3>
            <div class="mt-2 w-full">
              <%= render "form", task: @task %>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<% end %>

app/views/tasks/index.html.erb
<%= turbo_frame_tag :task do %>
  <%= render partial: 'shared/dashboard' %>
<% end %>

app/views/tasks/index.turbo_stream.erb
	<%= turbo_frame_tag :tasks, class: 'space-y-8 pt-10' do %>
    <%= render @tasks %>
  <% end %>

app/views/tasks/new.html.erb
<%= turbo_frame_tag :task do %>
  <!-- <h1 class="text-4xl font-bold m-6 text-gray-600">New task</h1> -->

  <!-- This example requires Tailwind CSS v2.0+ -->
<div class="fixed z-10 inset-0 overflow-y-auto" aria-labelledby="modal-title" role="dialog" aria-modal="true">
  <div class="flex items-end justify-center min-h-screen pt-4 px-4 pb-20 text-center sm:block sm:p-0">
    <div class="fixed inset-0 bg-gray-500 bg-opacity-75 transition-opacity" aria-hidden="true"></div>
    <!-- This element is to trick the browser into centering the modal contents. -->
    <span class="hidden sm:inline-block sm:align-middle sm:h-screen" aria-hidden="true">&#8203;</span>
    <div class="inline-block align-bottom bg-white rounded-lg text-left overflow-hidden shadow-xl transform transition-all sm:my-8 sm:align-middle sm:max-w-lg sm:w-full">
      <div class="bg-white px-4 pt-5 pb-4 sm:p-6 sm:pb-4">
        <div class="sm:flex sm:items-start">
          <div class="mx-auto flex-shrink-0 flex items-center justify-center h-12 w-12 rounded-full bg-red-100 sm:mx-0 sm:h-10 sm:w-10">
            <!-- Heroicon name: outline/exclamation -->
            <svg xmlns="http://www.w3.org/2000/svg" class="h-6 w-6 text-blue-600" fill="none" viewBox="0 0 24 24" stroke="currentColor">
              <path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M12 9v3m0 0v3m0-3h3m-3 0H9m12 0a9 9 0 11-18 0 9 9 0 0118 0z" />
            </svg>
          </div>
          <div class="mt-3 text-center sm:mt-0 sm:ml-4 sm:text-left w-full">
            <h3 class="text-lg leading-6 font-medium text-gray-900" id="modal-title">
              Create Task
            </h3>
            <div class="mt-2 w-full">
              <%= render "form", task: @task %>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<% end %>

app/views/tasks/show.html.erb
<%= turbo_frame_tag :task do %>
  <div class="p-4 border w-full bg-white">

    <%= render @task %>

    <p class="font-serif font-semibold text-gray-600">Status: <%= @task.status ? 'Complete' : 'Incomplete' %></p>
    <div class="mt-6 flex gap-2">
      <%= link_to "Edit this task", edit_task_path(@task), class: 'btn-success', 'data-turbo-frame': 'task' %>
      <%= link_to "Back to tasks", tasks_path, class: 'btn-info' %>

      <%= button_to "Destroy this task", @task, method: :delete, class: 'btn-danger' %>
    </div>
  </div>
<% end %>

app/views/tasks/update.turbo_stream.erb
<%# turbo_stream.replace(@task, target: '#tasks') do %>
  <%#  render partial: 'tasks/task', locals: { task: @task } %>
<%# end %>

<% if @task.errors.any? %>

  <%= turbo_stream.replace 'task_form' do %>
    <%= render partial: 'tasks/form', locals: { task: @task } %>
  <% end %>

<% else %>

  <%= turbo_stream.update :messages do %>
    <%= render partial: 'shared/flash', locals: { key: 'notice', message: 'Task updated successfully' } %>
  <% end %>

  <%= turbo_stream.replace :task do %>
    <%= turbo_frame_tag :task do %>
      <%= render partial: 'shared/dashboard' %>
    <% end %>
  <% end %>
  
<% end %>

app/views/users/shared/_error_messages.html.erb
<% if resource.errors.any? %>
  <div id="error_explanation">
    <h2>
      <%= I18n.t("errors.messages.not_saved",
                 count: resource.errors.count,
                 resource: resource.class.model_name.human.downcase)
       %>
    </h2>
    <ul>
      <% resource.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
    </ul>
  </div>
<% end %>

app/views/users/shared/_links.html.erb
<%- if controller_name != 'sessions' %>
  <%= link_to "Log in", new_session_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.registerable? && controller_name != 'registrations' %>
  <%= link_to "Sign up", new_registration_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.recoverable? && controller_name != 'passwords' && controller_name != 'registrations' %>
  <%= link_to "Forgot your password?", new_password_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.confirmable? && controller_name != 'confirmations' %>
  <%= link_to "Didn't receive confirmation instructions?", new_confirmation_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.lockable? && resource_class.unlock_strategy_enabled?(:email) && controller_name != 'unlocks' %>
  <%= link_to "Didn't receive unlock instructions?", new_unlock_path(resource_name) %><br />
<% end %>

<%- if devise_mapping.omniauthable? %>
  <%- resource_class.omniauth_providers.each do |provider| %>
    <%= link_to "Sign in with #{OmniAuth::Utils.camelize(provider)}", omniauth_authorize_path(resource_name, provider), method: :post %><br />
  <% end %>
<% end %>